/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (4.2.2).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package com.t5g.nf.ausf.ueauthentication.api;

import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import com.t5g.nf.ausf.ueauthentication.model.AuthenticationInfo;
import com.t5g.nf.ausf.ueauthentication.model.ConfirmationData;
import com.t5g.nf.ausf.ueauthentication.model.ConfirmationDataResponse;
import com.t5g.nf.ausf.ueauthentication.model.EapSession;
import com.t5g.nf.ausf.ueauthentication.model.ProblemDetails;
import com.t5g.nf.ausf.ueauthentication.model.UEAuthenticationCtx;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2019-12-17T16:19:50.870+02:00[Europe/Helsinki]")

@Validated
@Api(value = "ue-authentications", description = "the ue-authentications API")
public interface UeAuthenticationsApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    @ApiOperation(value = "", nickname = "eapAuthMethod", notes = "", response = EapSession.class, authorizations = {
        @Authorization(value = "oAuth2ClientCredentials", scopes = {
            @AuthorizationScope(scope = "nausf-auth", description = "Access to Nausf_UEAuthentication API")
            })
    }, tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Use to handle or close the EAP session", response = EapSession.class),
        @ApiResponse(code = 400, message = "Bad Request", response = ProblemDetails.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = ProblemDetails.class) })
    @RequestMapping(value = "/ue-authentications/{authCtxId}/eap-session",
        produces = { "application/json", "application/3gppHal+json", "application/problem+json" }, 
        consumes = { "application/json" },
        method = RequestMethod.POST)
    default ResponseEntity<EapSession> eapAuthMethod(@ApiParam(value = "",required=true) @PathVariable("authCtxId") String authCtxId,@ApiParam(value = ""  )  @Valid @RequestBody EapSession eapSession) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    String exampleString = "{ \"eapPayload\" : \"eapPayload\", \"_links\" : { }, \"kSeaf\" : \"kSeaf\", \"supi\" : \"supi\" }";
                    ApiUtil.setExampleResponse(request, "application/json", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "", nickname = "ueAuthenticationsAuthCtxId5gAkaConfirmationPut", notes = "", response = ConfirmationDataResponse.class, authorizations = {
        @Authorization(value = "oAuth2ClientCredentials", scopes = {
            @AuthorizationScope(scope = "nausf-auth", description = "Access to Nausf_UEAuthentication API")
            })
    }, tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Request processed (EAP success or Failure)", response = ConfirmationDataResponse.class),
        @ApiResponse(code = 400, message = "Bad Request", response = ProblemDetails.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = ProblemDetails.class) })
    @RequestMapping(value = "/ue-authentications/{authCtxId}/5g-aka-confirmation",
        produces = { "application/json", "application/problem+json" }, 
        consumes = { "application/json" },
        method = RequestMethod.PUT)
    default ResponseEntity<ConfirmationDataResponse> ueAuthenticationsAuthCtxId5gAkaConfirmationPut(@ApiParam(value = "",required=true) @PathVariable("authCtxId") String authCtxId,@ApiParam(value = ""  )  @Valid @RequestBody ConfirmationData confirmationData) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    String exampleString = "{ \"kseaf\" : \"kseaf\", \"supi\" : \"supi\" }";
                    ApiUtil.setExampleResponse(request, "application/json", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "", nickname = "ueAuthenticationsPost", notes = "", response = UEAuthenticationCtx.class, authorizations = {
        @Authorization(value = "oAuth2ClientCredentials", scopes = {
            @AuthorizationScope(scope = "nausf-auth", description = "Access to Nausf_UEAuthentication API")
            })
    }, tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "UEAuthenticationCtx", response = UEAuthenticationCtx.class),
        @ApiResponse(code = 400, message = "Bad Request from the AMF", response = ProblemDetails.class),
        @ApiResponse(code = 403, message = "Forbidden due to serving network not authorized", response = ProblemDetails.class),
        @ApiResponse(code = 404, message = "User does not exist in the HPLMN", response = ProblemDetails.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = ProblemDetails.class),
        @ApiResponse(code = 501, message = "Received protection scheme is not supported by HPLMN", response = ProblemDetails.class) })
    @RequestMapping(value = "/ue-authentications",
        produces = { "application/3gppHal+json", "application/problem+json" }, 
        consumes = { "application/json" },
        method = RequestMethod.POST)
    default ResponseEntity<UEAuthenticationCtx> ueAuthenticationsPost(@ApiParam(value = "" ,required=true )  @Valid @RequestBody AuthenticationInfo authenticationInfo) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf(""))) {
                    String exampleString = "";
                    ApiUtil.setExampleResponse(request, "", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
